//----------------------------------------------------------------------------------------------------------
//                            
//
//            SciLab 
//    
//----------------------------------------------------------------------------------------------------------


//  Scilab,             
//  .          
//     .         
// ,    .

//   ,       L,  
//      fi(x).     
// u(0,t)=U1=const, u(L,t)=U2=const

//        

//   .
function y=f(x,t)
y=sin(x*t)
endfunction

// 
function y=fi(x)
y=exp(0.15*x)
endfunction

//   
function y=myu(t)
y=1
endfunction

//   
function y=nyu(x)
y=2.117
endfunction

function [u,x,t]=parabol(N,K,L,T,a)
//       
//    . N -  ,
//       (0,L); K  
// ,      t (0,T); a -
//    ,
//     u   x, t

//    
h=L/N;
//    t
delta=T/K;
//   x      U   
for i=1:N+1
  x(i)=(i-1)*h;
  u(i,1)=fi(x(i));
end
//   t,       U   
for j=1:K+1
  t(j)=(j-1)*delta;
  u(1,j)=myu(t(j));
  u(N+1,j)=nyu(t(j));
end
gam=a^2*delta/h^2;
//    u     
for j=1:K
for i=2:N
u(i,j+1)=gam*u(i-1,j)+(1-2*gam)*u(i,j)+gam*u(i+1,j)+delta*f(x(i),t(j));
end
end
endfunction

[U,X,T]=parabol(50,200,5,3,0.4);
surf(X,T,U');
title('PARABOLIC EQUATION');
xlabel('X');
ylabel('T');

clear;

//             
//      .        
//  .    ,       
//  .       .

//   
function y=f(x,t)
y=sin(x*t)
//y=0;
endfunction

// 
function y=fi(x)
y=exp(0.15*x)
endfunction

//   
function y=myu(t)
y=1
endfunction

//   
function y=nyu(x)
y=2.117
endfunction

function [u,x,t,r,k]=neyavn(N,K,L,T,a,eps)
//       
//    . N -  ,
//       (0,L);
// K -  ,     
// t (0,T); a -   
// , eps -   
//  .
//  neyavn :
// u -     ,  x,  t,
// r -    (12.14)  ,  -
//      (7.14) 
// .

//    
h=L/N;
//    t
delta=T/K;
//   x      U 
//   
for i=1:N+1
x(i)=(i-1)*h;
u(i,1)=fi(x(i));
end
//   t,     
//  U   
for j=1:K+1
t(j)=(j-1)*delta;
u(1,j)=myu(t(j));
u(N+1,j)=nyu(t(j));
end
//    R     
R(N+1,K+1)=0;
//   gamma
gam=a^2*delta/h^2;
r=1;
k=0;
//  while     
//        eps 
while r>eps
//    R   
//    u      
//  
for i=2:N
for j=2:K+1
R(i,j)=abs(u(i,j)-gam/(1+2*gam)*(u(i-1,j)+u(i+1,j))-u(i,j-1)/(1+2*gam)-delta*f(x(i),t(j))/(1+2*gam));
u(i,j)=gam/(1+2*gam)*(u(i-1,j)+u(i+1,j))+u(i,j-1)/(1+2*gam)+delta*f(x(i),t(j))/(1+2*gam);
end
end
//     
r=R(1,1);
for i=1:N+1
for j=1:K+1
if R(i,j)>r 
r=R(i,j);
end
end
end
//   
k=k+1;
end
disp(k)
endfunction

[U,X,T]=neyavn(50,200,5,3,0.4,0.1);
clf();
surf(X,T,U');
title('PARABOLIC EQUATION');
xlabel('X');
ylabel('T');

clear;

//      ,  f (x , t)?0,    
//   .
//       L,     
//   f(x).     u(0,t)=U1=const, u(L,t)=U2=const.
//           ,  
//   u0.

// 
function y=fi(x)
y=exp(0.15*x)
endfunction

function [u,x,t,r,k]=neiav(N,K,L,T,a,h,U1,U2,u0,eps)
//           . 
// N -  ,       (0,L); K -  , 
//      t (0,T);
// a, h -     ;
// eps -     ;
// U1 -     ;
// U2 -     ;
//  neiav :
// u -     ,  x,  t,
// r -     ,
//  -       .

//    
hx=L/N;
//    t
delta=T/K;
//   x      U   
for i=1:N+1
x(i)=(i-1)*hx;
u(i,1)=fi(x(i));
end
//   t,       U   
for j=1:K+1
t(j)=(j-1)*delta;
u(1,j)=U1;
u(N+1,j)=U2;
end
//    R     
R(N+1,K+1)=0;
//   gamma
gam=a^2*delta/hx^2;
r=1;
k=0;
//  while          
//   eps 
while r>eps
//    R       u     
//    
for j=2:K+1
for i=2:N
V=gam*(u(i-1,j)+u(i+1,j))/(1+2*gam+delta*hx)+u(i,j-1)/(1+2*gam+delta*hx)+delta*h*u0/(1+2*gam+delta*hx);
R(i,j)=abs(V-u(i,j));
u(i,j)=V;
end
end
//     
r=R(1,1);
for i=1:N+1
for j=1:K+1
if R(i,j)>r 
r=R(i,j);
end
end
end
//   
k=k+1;
end
endfunction

//   
[U,X,T,R,K]=neiav(50,200,5,3,0.4,0.5,1,2.117,30,0.001);
clf();
//  
surf(X,T,U');
title('Example');
xlabel('X');
ylabel('T');

clear;

//       .
//  - .

//   .
function y=f(x,t)
y=sin(x*t)
endfunction

function y=fi(x)
y=exp(0.15*x)
endfunction

function y=psi(x)
y=exp(0.25*x)
endfunction

function [u,x,t]=ggg(N,K,L,T,a)
//         . 
//  :
// N -  ,       (0,L); K -  , 
//      t (0,T); a -    
// . 
//  :
// u -     ,  x,  t,

//    
h=L/N;
//    t
delta=T/K;
//   x,       u   
for i=1:N+1
x(i)=(i-1)*h;
u(i,1)=fi(x(i));
u(i,2)=u(i,1)+delta*psi(x(i));
end
//   t,       U   
for j=1:K+1
t(j)=(j-1)*delta;
end
//        U   
for j=2:K+1
u(1,j)=0;
u(N+1,j)=fi(L);
end
gam=a^2*delta^2/h^2;
//    u     
for j=2:K
for i=2:N
u(i,j+1)=-u(i,j-1)+gam*u(i-1,j)+(2-2*gam)*u(i,j)+gam*u(i+1,j)+delta^2*f(x(i),t(j));
end
end
endfunction 
  
//   
[U,X,T]=ggg(50,200,5,3,0.4);
clf();
//  
surf(X,T,U');
title('Example ggg');
xlabel('X');
ylabel('T');

//         ,     ,
//        ,    ,   
//      , ,      
// 

//       .

clear;

function [Psi,x,y,k]=ellip(R,a,b,Nx,Ny,eps)
//  ellip  .
//  :
// R, a, b - ,    ,
// Nx -  ,      (R-b,R+b);
// Ny -  ,      y (-a,a);
// eps -    (12.26)  .
//  :
// Psi -     ,  x,  y,
// k -        .

//    y
hy=2*a/Ny;
//    x
hx=2*b/Nx;
//   x,       Psi   
for i=1:Nx+1
x(i)=R-b+(i-1)*hx;
Psi(i,1)=0;
Psi(i,Ny+1)=0;
end;
//   y,       Psi   
for j=1:Ny+1
y(j)=-a+(j-1)*hy;
Psi(1,j)=0;
Psi(Nx+1,1)=0;
end;
//    
A=2/hy^2+2/hx^2;
D=1/hy^2;
for i=2:Nx+1
B(i)=1/hx^2+5/(2*hx*x(i));
C(i)=1/hx^2-5/(2*hx*x(i));
end
//       eps
p=1;
k=0;
while p>eps
for i=2:Nx
for j=2:Ny
V=1/A*(B(i)*Psi(i-1,j)+C(i)*Psi(i+1,j)+D*(Psi(i,j-1)+Psi(i,j+1))+2);
R(i,j)=abs(V-Psi(i,j));
Psi(i,j)=V;
end
end 
p=R(2,2);
for i=2:Nx
for j=2:Ny
if R(i,j)>p
p=R(i,j);
end
end
end
k=k+1;
end
endfunction

//   
[PSI,X,Y,K]=ellip(18,3,6,32,16,0.01);
//  
clf();
surf(X,Y,PSI');
title('Example el');
xlabel('X');
ylabel('Y');

//          ,  
//  ,          
//  .  

//          .    
//  ,    ,      
//     .        
// ,        freefem.


clear
//----------------------------------------------------------------------------------------------------------

