//Codec of file is UTF-8
//-----------------------------------------------------------------------
//        Построение и оформление 2D графиков с помощью plot
//
// 
// Составлено с использованием учебника Алексеева, адаптировано под 
// Scilab 5.5.2
//-----------------------------------------------------------------------

x=[-2*%pi:0.1:2*%pi]';
y=sin(cos(x));
xtitle('plot function y=sin(cos(x))','X','Y');
plot(x,y);
halt;
clf();
clear;

x=-2*%pi:0.1:2*%pi;
plot(x,[sin(cos(x));cos(sin(x));exp(sin(x));exp(cos(x))]);
halt; 
clf();
clear;

x=[-2*%pi:0.1:2*%pi]';
y=sin(x/2); 
z=cos(x);
v=exp(cos(x));
plot(x,y,'--');
plot(x,z,'k*');
plot(x,v,'r.--');
halt; 
clf();
clear;

// legend(leg1,leg2,...,legn,[pos],[boxed])
// leg1 - имя первого графика, leg2 - имя второго графика, legn - имя n-го 
// графика;
// pos - месторасположение легенды: 
// 1 - в верхнем правом углу (по умолчанию), 
// 2 - в верхнем левом углу,
// 3 - в нижнем левом углу, 4 - в нижнем правом углу, 
// 5 - определяется пользователем после изображения графика;
// boxed - логическая переменная, которая определяет прорисовывать 
// (%t, по умолчанию) или нет (%f) рамку вокруг легенды;

x=-10:0.01:10;
y=sin(cos(x));
z=cos(sin(x));
plot(x,y,'r',x,z,'b');
xgrid();
xtitle('Grafic','X','Y');
legend('sin(cos(x))','cos(sin(x))',3,%f);
halt; 
clf();
clear;

// Простым способом изображения нескольких графиков в одном окне является 
// использование функции subplot. Она разделяет графическое окно на
// несколько отдельных областей, имеет простой синтаксис. Обращение к ней 
// имеет вид:
//
// subplot(m,n,p) или subplot(mnp)
//
// Выполнение функции приводит к тому, что графическое окно разбивается на
// m окон по вертикали и n окон по горизонтали, текущим окном становится 
// окно с номером p.

x=[-10:0.01:10];
y=sin(x); 
z=cos(x);
u=cos(sin(x)); 
v=sin(cos(x));
w=exp(sin(x)); 
r=exp(cos(x));
subplot(3,2,1);
plot(x,y);
subplot(3,2,2);
plot(x,z);
subplot(3,2,3);
plot(x,u);
subplot(3,2,4);
plot(x,v);
subplot(3,2,5);
plot(x,w);
subplot(3,2,6);
plot(x,r);

clear;

// Для формирования области в графическом окне служит также команда plotframe:
// -- УСТАРЕЛА
