//Codec of file is UTF-8
//-----------------------------------------------------------------------
//       Построение и оформление 2D графиков с помощью plot2d
//
// 
// Составлено с использ. учебника Алексеева, проверено в Scilab 5.5.2
//-----------------------------------------------------------------------

x=[-2*%pi:0.1:2*%pi]';
plot2d(x,[sin(x) sin(2*x) sin(3*x)]);
halt; 
clf();

x=[-2*%pi:0.1:2*%pi];
y=[sin(x);cos(x)];
plot2d(x,y',style=[color("red"), color(0,176,0)]);
halt; 
clf();

x=[-2*%pi:0.1:2*%pi];
y=[sin(x);cos(x)];
plot2d(x,y',style=[color("red"),color(0,176,0)],rect=[-8,-2,8,2]);
halt; 
clf();

x=[-2*%pi:0.1:2*%pi];
y=[sin(x); cos(x)];
subplot(2,2,1)
plot2d(x,y',style=[color("red"), color("blue")], axesflag=0);
subplot(2,2,2)
plot2d(x,y',style=[color("red"), color("blue")], axesflag=1);
subplot(2,2,3)
plot2d(x,y',style=[color("red"), color("blue")], axesflag=3);
subplot(2,2,4)
plot2d(x,y',style=[color("red"), color("blue")], axesflag=5);
halt; 
clf();

// Для того, чтобы определить число основных и промежуточных делений 
// координатных осей существует параметр nax. Если параметр axesflag=1 (по 
// умолчанию) - это массив из четырех значений [nx, Nx, ny, Ny]. Здесь 
// Nx (Ny) - число основных делений с подписями под осью Х (Y), nx (ny) - 
// число промежуточных делений;
// Например, nax=[4,9,3,6]: ось X будет разбита 9 основными делениями, 
// каждое основное 4 промежуточными, а ось Y - 6 и 3 соответственно.

x=[-8:0.1:8];
y=[sin(x); cos(x)];
plot2d(x,y',style=[color("red"),color("blue")],axesflag=1,nax=[4,9,3,6]);
halt; 
clf();

x=[-2*%pi:0.1:2*%pi];
y=[sin(x); cos(x)];
plot2d(x,y',axesflag=5, leg="sin(x)@cos(x)");
halt; 
clf();

x=[-2*%pi:0.25:2*%pi];
y=sin(x);
plot2d(x,y,-8);

clear
