//Codec of file is UTF-8
//-----------------------------------------------------------------------
//          Построение и оформление 2D графиков, дополнение
//                    (polarplot и plot2d2)
//
// 
// Составлено с использ. учебника Алексеева, проверено в Scilab 5.5.2
//-----------------------------------------------------------------------

// Для изображения графика в виде ступенчатой линии в Scilab существует
// функция plot2d2(x,y). Она полностью совпадает по синтаксису с функцией
// plot2d. Главное отличие состоит в том, что X и Y могут быть независимыми
// друг от друга функциями, важно лишь, чтобы массивы X и Y были разбиты на
// одинаковое количество интервалов.

x=[1947 1958 1970 1980 1999 2006];
y=[2.003 3.1 3.6 4.7 5.2 5.4];
plot2d2(x,y);
halt; 
clf();

// В Scilab для формирования графика в полярной системе координат необходимо 
// сформировать массивы значений полярного угла и полярного радиуса, а
// затем обратиться к функции polarplot.

// Пример. Построим полярные графики функций ρ = 3cos(5ϕ) и ρ1 = 3cos(3ϕ).

//Определив диапазон и шаг изменения полярного угла, формируем 
// массивы fi, ro. Поочередно строим заданные кривые с помощью функции 
// polarplot, при этом для линии графика функции ro установим красный цвет, 
// а для функции ro1 — синий.
fi=0:0.01:2*%pi;
ro=3*cos(5*fi);ro1=3*cos(3*fi);
polarplot(fi,ro,style=color("red"));
polarplot(fi,ro1,style=color("blue"));

clear
