//Codec of file UTF-8
//-----------------------------------------------------------------------
// ВЕКТОРА, МАТРИЦЫ И ОПЕРАЦИИ С НИМИ (ПРОСТЫЕ)
// 
// Составлено по учебнику Алексеева, проверено в Scilab 5.5.2
//-----------------------------------------------------------------------


// Простейший способ задать массив (вектор-строку):
Xn=-3.5; dX=1.5; Xk=4.5; //нач. знач., шаг, конеч. знач.
X=Xn:dX:Xk

// Или с шагом единица:
X = -3:4

// Примеры ввода вектора-строки поэлементно:
V=[1 2 3 4 5]
W=[1.1,2.3,-0.1,5.88]

// Пример ввода вектора-столбца. Элементы вектора-столбца вводятся через 
// точку с запятой
X=[1;2;3]

// Ввод элементов матрицы, так же осуществляется в квадратных скобках; 
// при этом элементы строки отделяются друг от друга пробелом или запятой,
// а строки разделяются между собой точкой с запятой
A=[1 2 3; 4 5 6; 7 8 9]

// Матрицы и векторы можно формировать составляя их из ранее заданных 
// матриц и векторов

v1=[1 2 3]; v2=[4, 5, 6]; v3=[7 8 9]; // пример векторов-строк

//Горизонтальная конкатенация векторов–строк:
V=[v1 v2 v3]

//Вертикальная конкатенация векторов–строк, результат матрица:
V=[v1; v2; v3]

//Горизонтальная конкатенация матриц:
M=[V V V]

//Вертикальная конкатенация матриц:
M=[V; V]

// Важную роль при работе с матрицами играет знак двоеточия. Указывая его 
// вместо индекса при обращении к массиву, можно иметь доступ к группам его 
// элементов.
// Например, пусть задана матрица А
A=[5 7 6 5; 7 10 8 7; 6 8 10 9; 5 7 9 10]

//Выделить из матрицы А второй столбец
A(:,2)

//Выделить из матрицы А третью строку
A(3,:)

//Выделить из матрицы А подматрицу М
M=A(3:4,2:3)

//Удалить из матрицы А второй столбец
A(:,2)=[]

//Удалить из матрицы А третью строку
A(3,:)=[]

//Представить матрицу М в виде вектора–столбца
v=M(:)

//Выделить из вектора v элементы со второго по четвертый
b=v(2:4)

//Удалить из массива b второй элемент
b(2)=[]

// "Левое" и "правое" деление матриц

A=[3 2;4 3]
B=[-1 7;3 5]

//Решение матричного уравнения AX=B:
X=A\B

A*X-B // Проверка - должны быть нули

//Решение матричного уравнения XA=B:
X=B/A

X*A-B // Проверка - должны быть нули

// Применение функции к вектору или матрице

x=[0.1 -2.2 3.14 0 -1];

sin(x)

clear

