//Codec of file is UTF-8
//-----------------------------------------------------------------------
//               СПЕЦИАЛЬНЫЕ МАТРИЧНЫЕ ФУНКЦИИ
// 
// Составлено по учебнику Алексеева, адаптировано под Scilab 5.5.2
//-----------------------------------------------------------------------

D=[1 2; 3 4; 5 6]
matrix(D,2,3) // Преобразование в матрицу другого размера

m=3; n=2;
X=ones(m,n) // Формируется матрица размерностью m на n из единиц

M=[1 2 3; 4 5 6]
// Формируется матрица Y, состоящая из единиц, той же размерности, что и 
// матрица M
Y=ones(M)

zeros(3,2) // Задает нулевую матрицу
Z=zeros(M) // Аналогично с размерностью матрицы М

m=3; n=4; // Формирует единичную матрицу размерности m на n
E=eye(m,n)

M=[0 1;2 3]
// Формируется единичная матрица E той же размерности, что и матрица M
E=eye(M)

// Функцию можно использовать без параметров eye(), в этом случае задается 
// матрица с неопределенными размерами, которые будут определены после 
// суммирования с другой, определенной ранее, матрицей.
M=[1 2;3 4;5 6], E=eye();
A=E+M

// rand(n1,n2,…nn[,fl]) формирует многомерную матрицу случайных чисел, 
// нeобязательный параметр fl - это символьная переменная, с помощью которой 
// можно задать тип распределения случайной величины ('uniform' - равномерное, 
// 'normal' - гауссовское)
rand(2,2) // Матрица 2 на 2 случайных чисел
R=rand(2,2,2) // Многомерный массив случайных чисел

rand(M) // Формирует матрицу случайных чисел размер которой совпадает с 
// размером матрицы М

rand() // Случайное число

// sparse([i1   j1; i2   j2; …;in   jn],[n1,n2,…,nn]) формирует разреженную 
// матрицу; для создания матрицы такого типа необходимо указать индексы ее 
// ненулевых элементов [i1 j1,i2 j2,…,in jn] и их значения [n1,n2,…,nn]; 
// индексы одного элемента отделяются друг от друга либо пробелом, либо 
// запятой, а пары индексов соответственно точкой с запятой; значения 
// элементов разделяются запятыми. При попытке просмотреть матрицу подобного 
// типа пользователю будет предоставлено сообщение о ее размерности а так 
// же значения ненулевых элементов и их местоположение.

A=sparse([1 3;3 2;3 5],[4,5,6])

full(A) // Вывод разреженной матрицы в виде таблицы

// hypermat(D[,V]) - создание многомерной матрицы с размерностью заданной 
// вектором D и значениями элементов, хранящихся в векторе V (использование 
// параметра V необязательно)

// Пример создания матрицы М, состоящей из трех матриц размерностью два на 
// два, каждый элемент матрицы – член последовательности целых чисел от 0 
// до 11

M=hypermat([2 2 3],0:11)

// diag(V[,k])- возвращает квадратную матрицу с элементами V на главной 
// диагонали или на k-ой

V=[1,2,3];
diag(V) //V на главной диагонали

diag(V,1) //V на первой диагонали (выше главной)

diag(V,-1) //V на первой диагонали (ниже главной)

// diag(A [, k]), где A ранее определенная матрица - в качестве результата 
// выдаст вектор столбец, содержащий элементы главной или k-ой диагонали 
// матрицы А

A=[-1 2 0 ;2 1 -1 ;2 1 3]
diag(A) //Главная диагональ матрицы А
diag(A,-1) //Диагональ матрицы А, на 1 ниже главной

// cat(n, A, B, [C, …]) - объединяет матрицы А и В или все входящие матрицы 
// при n=1 по строкам, при n=2 - по столбцам; то же что [A; B] или [A, B]

A=[1 2;3 4]
B=[5 6 ;7 8]
cat(1,A,B) //Объединение матриц по строкам
cat(2,A,B) //Объединение матриц по столбцам

// tril(A[,k]) - формирует из матрицы А нижнюю треугольную матрицу, начиная 
// с главной или с k-й диагонали
// triu(A[,k]) - формирует из матрицы А верхнюю треугольную матрицу, начиная 
// с главной или с k-ой диагонали

A=[1 2 3;4 5 6;7 8 9]
tril(A,-2) //Нижняя треуг. матрица, начиная со второй диаг.(ниже главной)
triu(A,-1) //Верхняя треуг. матрица, начиная с первой диаг.(ниже главной)

// gsort(X) - выполняет упорядочивание массива X 

b=[2 0 1]
gsort(b) //сортировка по убыванию
-gsort(-b) //сортировка по возрастанию
gsort(b,'g','i') //аналогично

A=[1 2 0; -1 3 1; 4 -2 5]
gsort(A) //сортировка матрицы
gsort(A,'c') //сортировка матрицы; сорт. каждая строка


clear
